#! /bin/env python
#Last run took 2 hours, 22 minutes
import os
import phaseVsPhase as pvp
import pacsplot
def pipelineOn(outroot,filelist,stepsString,options="",step=1):
    os.chdir(outroot)
    for project,root in filelist:
        print project
        os.system("mkdir "+project)
        os.chdir(project)
        os.system("pipepar -c datadir=%s project=%s showPlots=False%s"%(root,project,options))
        os.system("$DRPACS/templates/pipeline/mksteps.py "+stepsString+" > Pipefile")
        os.system("pipe step%i all>&pipe.log"%step)
        os.chdir("..")
def batchPipe(root=None,outroot="./pipeoutput",*args,**kwargs):
    """
    Usage: batchPipe(root,[output file],["update"],[whitelist=__],[blacklist=__])
    Purpose: Determines the times when both SZA and the rest of CARMA are
    focused on the same target at the same time for multiple observations.
    Input:
        root: The directory to search for miriad files.
        outputfile:The file to put the results in; will be pipeoutput unless specified
        "update":Specifying this will only examine datasets that don't have an
            existing output file.
        whitelist:This specifies a text file, containing entries of the same form as
            cx252.2A_230Arp193.5. All files in root will be examined unless whitelist
            exists, in which case only files in whitelist will be used.
        blacklist:This specifies a text file, in the same format as whitelist, which
            specifies files to not be examined.
        Note that a file must pass all the filters to be examined (for example, if a
            blacklist and whitelist exist, it must be both on the whitelist and off
            the blacklist.
    """
    if root==None:
        print __doc__
        return
    home=os.getcwd()
    useswhitelist="whitelist" in kwargs
    usesblacklist="blacklist" in kwargs
    options=""
    if "options" in kwargs:
        for item in kwargs["options"]:
            options+=" %s=%s"%item
    step=1
    if "step" in kwargs:
        step=kwargs["step"]
    silent="silent" in args
    update="update" in args
    allFiles=[]
    if useswhitelist:
        fin=open(kwargs["whitelist"])
        whitelist=fin.read()
        fin.close()
    if usesblacklist:
        fin=open(kwargs["blacklist"])
        blacklist=fin.read()
        fin.close()
    if update:
        completelist=[]
        fin=os.popen("ls -l "+outroot)
        for line in fin.readlines()[1:]:
            completelist.append(line.split()[-1][:-4])
        fin.close()
    for root, dirs, files in os.walk(root):
        output=[]
        for file in files:
            #whitelist takes files in form cx252.2A_230Arp193.5
            #finds SZA files and then generates their CARMA pair because if the SZA files exist the CARMA ones will too.
            if ('.tar.gz' in file and 'zr' in file and file[2:-11]!="" and (not useswhitelist or file[2:-11] in whitelist)):
                if not (usesblacklist and file[2:-11]in blacklist) and not (update and file[2:-11] in completelist):
                    output.append((file[2:-11],root))
        allFiles=allFiles+output
    fin=open("%s/cat/pipeline.001"%os.environ["DRPACS"])
    steps=fin.read().split('\n')[:-1]
    fin.close()
    stepsString=str(len(steps))
    for item in steps:
        stepsString=stepsString+" "+item
    os.system("mkdir "+outroot)
    quarter=len(allFiles)/4
    args=[[outroot,allFiles[         :quarter  ],stepsString,options,step],
          [outroot,allFiles[quarter  :quarter*2],stepsString,options,step],
          [outroot,allFiles[quarter*2:-quarter ],stepsString,options,step],#May get stuck with 3 extras
          [outroot,allFiles[-quarter :         ],stepsString,options,step]]
    pacsplot.paralell(pipelineOn,args)
